<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { NextStep } from '~/components/common/index';
import {
  PlanSummary,
  NoImageAccordion,
  CaseStudyCarousel,
  RoiCalculatorBlock,
  FeaturesBlock,
  GuestCalculator,
} from '~/components/pricing/plans/index';

export default Vue.extend({
  components: {
    PlanSummary,
    NoImageAccordion,
    CaseStudyCarousel,
    RoiCalculatorBlock,
    FeaturesBlock,
    NextStep,
    GuestCalculator,
  },
  nuxtI18n: false,
  async asyncData({ $content, params, error }: any) {
    try {
      const doc = await $content(
        `pricing/${params.pricing ? params.pricing : 'index'}`,
      ).fetch();

      // features
      const relatedContent = await $content('features/related-data').fetch();
      const featuresContent = await $content('synced/features').fetch();

      return { doc, relatedContent, featuresContent };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  data() {
    return {
      completed: false,
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).doc, this.$route.path);
  },
  mounted() {
    this.completed = true;
  },
});
</script>

<template>
  <div class="pricing-plan">
    <script src="//page.gitlab.com/js/forms2/js/forms2.min.js"></script>
    <SlpContainer>
      <SlpSideNavigation :data="doc.side_menu">
        <template #header>
          <div class="pricing-plan__nav-buttons">
            <SlpButton
              v-for="(button, buttonIndex) in doc.side_menu.hyperlinks.data"
              :key="buttonIndex"
              :variant="button.variant"
              :href="button.href"
              :data-ga-name="button.data_ga_name"
              :data-ga-location="button.data_ga_location"
              >{{ button.text }}
              <SlpIcon
                v-if="button.icon"
                class="slp-ml-8"
                name="chevron-lg-right"
                variant="product"
                alt="Chevron Right Icon"
              />
            </SlpButton>
          </div>
        </template>
        <div id="overview" class="pricing-plan__content">
          <component
            :is="component.name"
            v-for="component in doc.components"
            :key="component.name"
            :data="component.data"
          />
          <FeaturesBlock
            v-if="completed"
            :data="doc.features_block"
            :features="featuresContent.features"
            :related-content="relatedContent"
          />
        </div>
      </SlpSideNavigation>
      <SlpSideButton data-ga-name="to-top" data-ga-location="body" />
    </SlpContainer>
    <SlpContainer id="get-in-touch" variant="gradient">
      <NextStep :disable-animations="true" />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.pricing-plan {
  @media (min-width: $breakpoint-md) {
    margin-top: $spacing-96;
    :deep {
      #collapsible-sidebar-content {
        max-width: calc(100% - 300px);
      }
    }
  }

  &__nav-buttons {
    margin-bottom: $spacing-24;
    .slp-btn {
      width: 100%;
      justify-content: center;
      margin-bottom: $spacing-8;
    }

    .slp-btn-secondary {
      padding: 11px 0;
    }
  }

  // sidenav is on mobile view
  @media (max-width: $breakpoint-md) {
    &:deep {
      .dropdown {
        margin: $spacing-32 0;
      }
      .slp-top-btn {
        display: none;
      }
    }
  }
}
</style>
